package main

import (
	"fmt"
	"net/http"
	"os"

	"gitlab.wodcloud.com/apaas/apaas-meshproxy/src/config"

	"github.com/spf13/pflag"
	"github.com/tav/golly/log"
	"gitlab.wodcloud.com/apaas/apaas-meshproxy/src/handler"
)

var (
	argPort  = pflag.Int("port", 8088, "")
	redisUrl = pflag.String("redisUrl", "redis://redis:16379", "")
	redisTag = pflag.String("redisTag", "apaas-mesh-proxy", "")
)

func main() {
	pflag.Parse()
	initEnv()
	initConfig()
	proxyhandler, _ := handler.CreateProxyHandler()
	counthandler, _ := handler.CreateCountHandler()
	http.Handle("/count", counthandler)
	http.Handle("/", proxyhandler)
	if err := http.ListenAndServe(fmt.Sprintf(":%d", *argPort), nil); err != nil {
		log.Error("Listen Server err:", err)
	}
}

//注册环境变量
func initEnv() {
	if len(os.Getenv("AWE_REDIS_CONNECTION")) > 0 {
		*redisUrl = os.Getenv("AWE_REDIS_CONNECTION")
	}
}

//注册公共config参数信息
func initConfig() {
	config.RedisTag = *redisTag
	config.RedisURL = *redisUrl
}
